package dev.thinhha.tunnel_server.controller;

import dev.thinhha.tunnel_server.dto.ClientDto;
import dev.thinhha.tunnel_server.service.ClientService;
import dev.thinhha.tunnel_server.utils.ResourceUtils;
import jakarta.validation.Valid;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.net.URISyntaxException;

@RestController
@RequestMapping("/clients")
public class ClientController {

    private final ClientService clientService;

    public ClientController(ClientService clientService) {
        this.clientService = clientService;
    }

    @PostMapping
    public ResponseEntity<ClientDto> createClient(final @Valid @RequestBody ClientDto body) throws URISyntaxException {
        var result = clientService.createClient(body);
        return ResponseEntity.created(ResourceUtils.buildResultUri()).body(result);

    }
}
