package dev.thinhha.tunnel_server.service.impl;

import com.fasterxml.jackson.databind.ObjectMapper;
import dev.thinhha.tunnel_server.dto.ClientDto;
import dev.thinhha.tunnel_server.entity.Client;
import dev.thinhha.tunnel_server.mapper.ClientMapper;
import dev.thinhha.tunnel_server.repository.ClientRepository;
import dev.thinhha.tunnel_server.service.ClientService;
import org.springframework.stereotype.Service;

@Service
public class ClientServiceImpl implements ClientService {
    private final ClientMapper clientMapper;
    private final ClientRepository clientRepository;
    private final ObjectMapper objectMapper;

    public ClientServiceImpl(ClientMapper clientMapper,
                             ClientRepository clientRepository,
                             ObjectMapper objectMapper) {
        this.clientMapper = clientMapper;
        this.clientRepository = clientRepository;
        this.objectMapper = objectMapper;
    }

    @Override
    public ClientDto createClient(ClientDto clientDto) {
        var client = objectMapper.convertValue(clientDto, Client.class);
        return objectMapper.convertValue(
                clientRepository.save(client), ClientDto.class
        );

    }

    @Override
    public ClientDto updateClient(ClientDto clientDto) {
        return null;
    }
}
