package dev.thinhha.tunnel_server.utils;

import dev.thinhha.tunnel_server.config.Constant;
import lombok.NonNull;

import java.security.SecureRandom;

public class RandomUtils {
    private static final SecureRandom secureRandom = new SecureRandom();

    private RandomUtils() {
    }

    public static @NonNull String generateAlphaNumericString(final int length) {
        return generateFromCharset(Constant.ALPHANUMERIC, length);
    }

    public static @NonNull String generateFromCharset(final @NonNull String charset, final int length) {
        var builder = new StringBuilder();
        for (int i = 0; i < length; i++) {
            var index = secureRandom.nextInt(charset.length());
            builder.append(charset.charAt(index));
        }
        return builder.toString();
    }

}
